# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from ... import _utilities, _tables
from . import outputs

__all__ = [
    'GoogleCloudDialogflowV2AutomatedAgentConfigResponse',
    'GoogleCloudDialogflowV2ContextResponse',
    'GoogleCloudDialogflowV2ConversationPhoneNumberResponse',
    'GoogleCloudDialogflowV2DocumentReloadStatusResponse',
    'GoogleCloudDialogflowV2EntityTypeEntityResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigConversationModelConfigResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigMessageAnalysisConfigResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionConfigResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionFeatureConfigResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigContextFilterSettingsResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDialogflowQuerySourceResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDocumentQuerySourceResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigKnowledgeBaseQuerySourceResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigResponse',
    'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionTriggerSettingsResponse',
    'GoogleCloudDialogflowV2HumanAgentHandoffConfigLivePersonConfigResponse',
    'GoogleCloudDialogflowV2HumanAgentHandoffConfigResponse',
    'GoogleCloudDialogflowV2HumanAgentHandoffConfigSalesforceLiveAgentConfigResponse',
    'GoogleCloudDialogflowV2IntentFollowupIntentInfoResponse',
    'GoogleCloudDialogflowV2IntentMessageBasicCardButtonOpenUriActionResponse',
    'GoogleCloudDialogflowV2IntentMessageBasicCardButtonResponse',
    'GoogleCloudDialogflowV2IntentMessageBasicCardResponse',
    'GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemOpenUrlActionResponse',
    'GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemResponse',
    'GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardResponse',
    'GoogleCloudDialogflowV2IntentMessageCardButtonResponse',
    'GoogleCloudDialogflowV2IntentMessageCardResponse',
    'GoogleCloudDialogflowV2IntentMessageCarouselSelectItemResponse',
    'GoogleCloudDialogflowV2IntentMessageCarouselSelectResponse',
    'GoogleCloudDialogflowV2IntentMessageColumnPropertiesResponse',
    'GoogleCloudDialogflowV2IntentMessageImageResponse',
    'GoogleCloudDialogflowV2IntentMessageLinkOutSuggestionResponse',
    'GoogleCloudDialogflowV2IntentMessageListSelectItemResponse',
    'GoogleCloudDialogflowV2IntentMessageListSelectResponse',
    'GoogleCloudDialogflowV2IntentMessageMediaContentResponse',
    'GoogleCloudDialogflowV2IntentMessageMediaContentResponseMediaObjectResponse',
    'GoogleCloudDialogflowV2IntentMessageQuickRepliesResponse',
    'GoogleCloudDialogflowV2IntentMessageResponse',
    'GoogleCloudDialogflowV2IntentMessageSelectItemInfoResponse',
    'GoogleCloudDialogflowV2IntentMessageSimpleResponseResponse',
    'GoogleCloudDialogflowV2IntentMessageSimpleResponsesResponse',
    'GoogleCloudDialogflowV2IntentMessageSuggestionResponse',
    'GoogleCloudDialogflowV2IntentMessageSuggestionsResponse',
    'GoogleCloudDialogflowV2IntentMessageTableCardCellResponse',
    'GoogleCloudDialogflowV2IntentMessageTableCardResponse',
    'GoogleCloudDialogflowV2IntentMessageTableCardRowResponse',
    'GoogleCloudDialogflowV2IntentMessageTextResponse',
    'GoogleCloudDialogflowV2IntentParameterResponse',
    'GoogleCloudDialogflowV2IntentTrainingPhrasePartResponse',
    'GoogleCloudDialogflowV2IntentTrainingPhraseResponse',
    'GoogleCloudDialogflowV2LoggingConfigResponse',
    'GoogleCloudDialogflowV2NotificationConfigResponse',
    'GoogleCloudDialogflowV2SpeechToTextConfigResponse',
    'GoogleCloudDialogflowV2SuggestionFeatureResponse',
    'GoogleRpcStatusResponse',
]

@pulumi.output_type
class GoogleCloudDialogflowV2AutomatedAgentConfigResponse(dict):
    """
    Defines the Automated Agent to connect to a conversation.
    """
    def __init__(__self__, *,
                 agent: str):
        """
        Defines the Automated Agent to connect to a conversation.
        :param str agent: Required. ID of the Dialogflow agent environment to use. This project needs to either be the same project as the conversation or you need to grant `service-@gcp-sa-dialogflow.iam.gserviceaccount.com` the `Dialogflow API Service Agent` role in this project. Format: `projects//locations//agent/environments/`. If environment is not specified, the default `draft` environment is used. Refer to [DetectIntentRequest](/dialogflow/docs/reference/rpc/google.cloud.dialogflow.v2#google.cloud.dialogflow.v2.DetectIntentRequest) for more details.
        """
        pulumi.set(__self__, "agent", agent)

    @property
    @pulumi.getter
    def agent(self) -> str:
        """
        Required. ID of the Dialogflow agent environment to use. This project needs to either be the same project as the conversation or you need to grant `service-@gcp-sa-dialogflow.iam.gserviceaccount.com` the `Dialogflow API Service Agent` role in this project. Format: `projects//locations//agent/environments/`. If environment is not specified, the default `draft` environment is used. Refer to [DetectIntentRequest](/dialogflow/docs/reference/rpc/google.cloud.dialogflow.v2#google.cloud.dialogflow.v2.DetectIntentRequest) for more details.
        """
        return pulumi.get(self, "agent")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2ContextResponse(dict):
    """
    Dialogflow contexts are similar to natural language context. If a person says to you "they are orange", you need context in order to understand what "they" is referring to. Similarly, for Dialogflow to handle an end-user expression like that, it needs to be provided with context in order to correctly match an intent. Using contexts, you can control the flow of a conversation. You can configure contexts for an intent by setting input and output contexts, which are identified by string names. When an intent is matched, any configured output contexts for that intent become active. While any contexts are active, Dialogflow is more likely to match intents that are configured with input contexts that correspond to the currently active contexts. For more information about context, see the [Contexts guide](https://cloud.google.com/dialogflow/docs/contexts-overview).
    """
    def __init__(__self__, *,
                 lifespan_count: int,
                 name: str,
                 parameters: Mapping[str, str]):
        """
        Dialogflow contexts are similar to natural language context. If a person says to you "they are orange", you need context in order to understand what "they" is referring to. Similarly, for Dialogflow to handle an end-user expression like that, it needs to be provided with context in order to correctly match an intent. Using contexts, you can control the flow of a conversation. You can configure contexts for an intent by setting input and output contexts, which are identified by string names. When an intent is matched, any configured output contexts for that intent become active. While any contexts are active, Dialogflow is more likely to match intents that are configured with input contexts that correspond to the currently active contexts. For more information about context, see the [Contexts guide](https://cloud.google.com/dialogflow/docs/contexts-overview).
        :param int lifespan_count: Optional. The number of conversational query requests after which the context expires. The default is `0`. If set to `0`, the context expires immediately. Contexts expire automatically after 20 minutes if there are no matching queries.
        :param str name: Required. The unique identifier of the context. Format: `projects//agent/sessions//contexts/`, or `projects//agent/environments//users//sessions//contexts/`. The `Context ID` is always converted to lowercase, may only contain characters in a-zA-Z0-9_-% and may be at most 250 bytes long. If `Environment ID` is not specified, we assume default 'draft' environment. If `User ID` is not specified, we assume default '-' user. The following context names are reserved for internal use by Dialogflow. You should not use these contexts or create contexts with these names: * `__system_counters__` * `*_id_dialog_context` * `*_dialog_params_size`
        :param Mapping[str, str] parameters: Optional. The collection of parameters associated with this context. Depending on your protocol or client library language, this is a map, associative array, symbol table, dictionary, or JSON object composed of a collection of (MapKey, MapValue) pairs: - MapKey type: string - MapKey value: parameter name - MapValue type: - If parameter's entity type is a composite entity: map - Else: depending on parameter value type, could be one of string, number, boolean, null, list or map - MapValue value: - If parameter's entity type is a composite entity: map from composite entity property names to property values - Else: parameter value
        """
        pulumi.set(__self__, "lifespan_count", lifespan_count)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "parameters", parameters)

    @property
    @pulumi.getter(name="lifespanCount")
    def lifespan_count(self) -> int:
        """
        Optional. The number of conversational query requests after which the context expires. The default is `0`. If set to `0`, the context expires immediately. Contexts expire automatically after 20 minutes if there are no matching queries.
        """
        return pulumi.get(self, "lifespan_count")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Required. The unique identifier of the context. Format: `projects//agent/sessions//contexts/`, or `projects//agent/environments//users//sessions//contexts/`. The `Context ID` is always converted to lowercase, may only contain characters in a-zA-Z0-9_-% and may be at most 250 bytes long. If `Environment ID` is not specified, we assume default 'draft' environment. If `User ID` is not specified, we assume default '-' user. The following context names are reserved for internal use by Dialogflow. You should not use these contexts or create contexts with these names: * `__system_counters__` * `*_id_dialog_context` * `*_dialog_params_size`
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def parameters(self) -> Mapping[str, str]:
        """
        Optional. The collection of parameters associated with this context. Depending on your protocol or client library language, this is a map, associative array, symbol table, dictionary, or JSON object composed of a collection of (MapKey, MapValue) pairs: - MapKey type: string - MapKey value: parameter name - MapValue type: - If parameter's entity type is a composite entity: map - Else: depending on parameter value type, could be one of string, number, boolean, null, list or map - MapValue value: - If parameter's entity type is a composite entity: map from composite entity property names to property values - Else: parameter value
        """
        return pulumi.get(self, "parameters")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2ConversationPhoneNumberResponse(dict):
    """
    Represents a phone number for telephony integration. It allows for connecting a particular conversation over telephony.
    """
    def __init__(__self__, *,
                 phone_number: str):
        """
        Represents a phone number for telephony integration. It allows for connecting a particular conversation over telephony.
        :param str phone_number: The phone number to connect to this conversation.
        """
        pulumi.set(__self__, "phone_number", phone_number)

    @property
    @pulumi.getter(name="phoneNumber")
    def phone_number(self) -> str:
        """
        The phone number to connect to this conversation.
        """
        return pulumi.get(self, "phone_number")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2DocumentReloadStatusResponse(dict):
    """
    The status of a reload attempt.
    """
    def __init__(__self__, *,
                 status: 'outputs.GoogleRpcStatusResponse',
                 time: str):
        """
        The status of a reload attempt.
        :param 'GoogleRpcStatusResponseArgs' status: The status of a reload attempt or the initial load.
        :param str time: The time of a reload attempt. This reload may have been triggered automatically or manually and may not have succeeded.
        """
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "time", time)

    @property
    @pulumi.getter
    def status(self) -> 'outputs.GoogleRpcStatusResponse':
        """
        The status of a reload attempt or the initial load.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def time(self) -> str:
        """
        The time of a reload attempt. This reload may have been triggered automatically or manually and may not have succeeded.
        """
        return pulumi.get(self, "time")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2EntityTypeEntityResponse(dict):
    """
    An **entity entry** for an associated entity type.
    """
    def __init__(__self__, *,
                 synonyms: Sequence[str],
                 value: str):
        """
        An **entity entry** for an associated entity type.
        :param Sequence[str] synonyms: Required. A collection of value synonyms. For example, if the entity type is *vegetable*, and `value` is *scallions*, a synonym could be *green onions*. For `KIND_LIST` entity types: * This collection must contain exactly one synonym equal to `value`.
        :param str value: Required. The primary value associated with this entity entry. For example, if the entity type is *vegetable*, the value could be *scallions*. For `KIND_MAP` entity types: * A reference value to be used in place of synonyms. For `KIND_LIST` entity types: * A string that can contain references to other entity types (with or without aliases).
        """
        pulumi.set(__self__, "synonyms", synonyms)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def synonyms(self) -> Sequence[str]:
        """
        Required. A collection of value synonyms. For example, if the entity type is *vegetable*, and `value` is *scallions*, a synonym could be *green onions*. For `KIND_LIST` entity types: * This collection must contain exactly one synonym equal to `value`.
        """
        return pulumi.get(self, "synonyms")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Required. The primary value associated with this entity entry. For example, if the entity type is *vegetable*, the value could be *scallions*. For `KIND_MAP` entity types: * A reference value to be used in place of synonyms. For `KIND_LIST` entity types: * A string that can contain references to other entity types (with or without aliases).
        """
        return pulumi.get(self, "value")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigConversationModelConfigResponse(dict):
    """
    Custom conversation models used in agent assist feature. Supported feature: ARTICLE_SUGGESTION, SMART_COMPOSE, SMART_REPLY.
    """
    def __init__(__self__, *,
                 model: str):
        """
        Custom conversation models used in agent assist feature. Supported feature: ARTICLE_SUGGESTION, SMART_COMPOSE, SMART_REPLY.
        :param str model: Required. Conversation model resource name. Format: `projects//conversationModels/`.
        """
        pulumi.set(__self__, "model", model)

    @property
    @pulumi.getter
    def model(self) -> str:
        """
        Required. Conversation model resource name. Format: `projects//conversationModels/`.
        """
        return pulumi.get(self, "model")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigMessageAnalysisConfigResponse(dict):
    """
    Configuration for analyses to run on each conversation message.
    """
    def __init__(__self__, *,
                 enable_entity_extraction: bool,
                 enable_sentiment_analysis: bool):
        """
        Configuration for analyses to run on each conversation message.
        :param bool enable_entity_extraction: Enable entity extraction in conversation messages on [agent assist stage](https://cloud.google.com/dialogflow/priv/docs/contact-center/basics#stages). If unspecified, defaults to false. Currently, this feature is not general available, please contact Google to get access.
        :param bool enable_sentiment_analysis: Enable sentiment analysis in conversation messages on [agent assist stage](https://cloud.google.com/dialogflow/priv/docs/contact-center/basics#stages). If unspecified, defaults to false. Sentiment analysis inspects user input and identifies the prevailing subjective opinion, especially to determine a user's attitude as positive, negative, or neutral: https://cloud.google.com/natural-language/docs/basics#sentiment_analysis For Participants.StreamingAnalyzeContent method, result will be in StreamingAnalyzeContentResponse.message.SentimentAnalysisResult. For Participants.AnalyzeContent method, result will be in AnalyzeContentResponse.message.SentimentAnalysisResult For Conversations.ListMessages method, result will be in ListMessagesResponse.messages.SentimentAnalysisResult If Pub/Sub notification is configured, result will be in ConversationEvent.new_message_payload.SentimentAnalysisResult.
        """
        pulumi.set(__self__, "enable_entity_extraction", enable_entity_extraction)
        pulumi.set(__self__, "enable_sentiment_analysis", enable_sentiment_analysis)

    @property
    @pulumi.getter(name="enableEntityExtraction")
    def enable_entity_extraction(self) -> bool:
        """
        Enable entity extraction in conversation messages on [agent assist stage](https://cloud.google.com/dialogflow/priv/docs/contact-center/basics#stages). If unspecified, defaults to false. Currently, this feature is not general available, please contact Google to get access.
        """
        return pulumi.get(self, "enable_entity_extraction")

    @property
    @pulumi.getter(name="enableSentimentAnalysis")
    def enable_sentiment_analysis(self) -> bool:
        """
        Enable sentiment analysis in conversation messages on [agent assist stage](https://cloud.google.com/dialogflow/priv/docs/contact-center/basics#stages). If unspecified, defaults to false. Sentiment analysis inspects user input and identifies the prevailing subjective opinion, especially to determine a user's attitude as positive, negative, or neutral: https://cloud.google.com/natural-language/docs/basics#sentiment_analysis For Participants.StreamingAnalyzeContent method, result will be in StreamingAnalyzeContentResponse.message.SentimentAnalysisResult. For Participants.AnalyzeContent method, result will be in AnalyzeContentResponse.message.SentimentAnalysisResult For Conversations.ListMessages method, result will be in ListMessagesResponse.messages.SentimentAnalysisResult If Pub/Sub notification is configured, result will be in ConversationEvent.new_message_payload.SentimentAnalysisResult.
        """
        return pulumi.get(self, "enable_sentiment_analysis")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigResponse(dict):
    """
    Defines the Human Agent Assist to connect to a conversation.
    """
    def __init__(__self__, *,
                 end_user_suggestion_config: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionConfigResponse',
                 human_agent_suggestion_config: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionConfigResponse',
                 message_analysis_config: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigMessageAnalysisConfigResponse',
                 notification_config: 'outputs.GoogleCloudDialogflowV2NotificationConfigResponse'):
        """
        Defines the Human Agent Assist to connect to a conversation.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionConfigResponseArgs' end_user_suggestion_config: Configuration for agent assistance of end user participant. Currently, this feature is not general available, please contact Google to get access.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionConfigResponseArgs' human_agent_suggestion_config: Configuration for agent assistance of human agent participant.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigMessageAnalysisConfigResponseArgs' message_analysis_config: Configuration for message analysis.
        :param 'GoogleCloudDialogflowV2NotificationConfigResponseArgs' notification_config: Pub/Sub topic on which to publish new agent assistant events.
        """
        pulumi.set(__self__, "end_user_suggestion_config", end_user_suggestion_config)
        pulumi.set(__self__, "human_agent_suggestion_config", human_agent_suggestion_config)
        pulumi.set(__self__, "message_analysis_config", message_analysis_config)
        pulumi.set(__self__, "notification_config", notification_config)

    @property
    @pulumi.getter(name="endUserSuggestionConfig")
    def end_user_suggestion_config(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionConfigResponse':
        """
        Configuration for agent assistance of end user participant. Currently, this feature is not general available, please contact Google to get access.
        """
        return pulumi.get(self, "end_user_suggestion_config")

    @property
    @pulumi.getter(name="humanAgentSuggestionConfig")
    def human_agent_suggestion_config(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionConfigResponse':
        """
        Configuration for agent assistance of human agent participant.
        """
        return pulumi.get(self, "human_agent_suggestion_config")

    @property
    @pulumi.getter(name="messageAnalysisConfig")
    def message_analysis_config(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigMessageAnalysisConfigResponse':
        """
        Configuration for message analysis.
        """
        return pulumi.get(self, "message_analysis_config")

    @property
    @pulumi.getter(name="notificationConfig")
    def notification_config(self) -> 'outputs.GoogleCloudDialogflowV2NotificationConfigResponse':
        """
        Pub/Sub topic on which to publish new agent assistant events.
        """
        return pulumi.get(self, "notification_config")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionConfigResponse(dict):
    """
    Detail human agent assistant config.
    """
    def __init__(__self__, *,
                 feature_configs: Sequence['outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionFeatureConfigResponse'],
                 group_suggestion_responses: bool):
        """
        Detail human agent assistant config.
        :param Sequence['GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionFeatureConfigResponseArgs'] feature_configs: Configuration of different suggestion features. One feature can have only one config.
        :param bool group_suggestion_responses: If `group_suggestion_responses` is false, and there are multiple `feature_configs` in `event based suggestion` or StreamingAnalyzeContent, we will try to deliver suggestions to customers as soon as we get new suggestion. Different type of suggestions based on the same context will be in separate Pub/Sub event or `StreamingAnalyzeContentResponse`. If `group_suggestion_responses` set to true. All the suggestions to the same participant based on the same context will be grouped into a single Pub/Sub event or StreamingAnalyzeContentResponse.
        """
        pulumi.set(__self__, "feature_configs", feature_configs)
        pulumi.set(__self__, "group_suggestion_responses", group_suggestion_responses)

    @property
    @pulumi.getter(name="featureConfigs")
    def feature_configs(self) -> Sequence['outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionFeatureConfigResponse']:
        """
        Configuration of different suggestion features. One feature can have only one config.
        """
        return pulumi.get(self, "feature_configs")

    @property
    @pulumi.getter(name="groupSuggestionResponses")
    def group_suggestion_responses(self) -> bool:
        """
        If `group_suggestion_responses` is false, and there are multiple `feature_configs` in `event based suggestion` or StreamingAnalyzeContent, we will try to deliver suggestions to customers as soon as we get new suggestion. Different type of suggestions based on the same context will be in separate Pub/Sub event or `StreamingAnalyzeContentResponse`. If `group_suggestion_responses` set to true. All the suggestions to the same participant based on the same context will be grouped into a single Pub/Sub event or StreamingAnalyzeContentResponse.
        """
        return pulumi.get(self, "group_suggestion_responses")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionFeatureConfigResponse(dict):
    """
    Config for suggestion features.
    """
    def __init__(__self__, *,
                 conversation_model_config: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigConversationModelConfigResponse',
                 enable_event_based_suggestion: bool,
                 query_config: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigResponse',
                 suggestion_feature: 'outputs.GoogleCloudDialogflowV2SuggestionFeatureResponse',
                 suggestion_trigger_settings: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionTriggerSettingsResponse'):
        """
        Config for suggestion features.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigConversationModelConfigResponseArgs' conversation_model_config: Configs of custom conversation model.
        :param bool enable_event_based_suggestion: Automatically iterates all participants and tries to compile suggestions. Supported features: ARTICLE_SUGGESTION, FAQ, DIALOGFLOW_ASSIST.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigResponseArgs' query_config: Configs of query.
        :param 'GoogleCloudDialogflowV2SuggestionFeatureResponseArgs' suggestion_feature: The suggestion feature.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionTriggerSettingsResponseArgs' suggestion_trigger_settings: Settings of suggestion trigger. Currently, only ARTICLE_SUGGESTION and FAQ will use this field.
        """
        pulumi.set(__self__, "conversation_model_config", conversation_model_config)
        pulumi.set(__self__, "enable_event_based_suggestion", enable_event_based_suggestion)
        pulumi.set(__self__, "query_config", query_config)
        pulumi.set(__self__, "suggestion_feature", suggestion_feature)
        pulumi.set(__self__, "suggestion_trigger_settings", suggestion_trigger_settings)

    @property
    @pulumi.getter(name="conversationModelConfig")
    def conversation_model_config(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigConversationModelConfigResponse':
        """
        Configs of custom conversation model.
        """
        return pulumi.get(self, "conversation_model_config")

    @property
    @pulumi.getter(name="enableEventBasedSuggestion")
    def enable_event_based_suggestion(self) -> bool:
        """
        Automatically iterates all participants and tries to compile suggestions. Supported features: ARTICLE_SUGGESTION, FAQ, DIALOGFLOW_ASSIST.
        """
        return pulumi.get(self, "enable_event_based_suggestion")

    @property
    @pulumi.getter(name="queryConfig")
    def query_config(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigResponse':
        """
        Configs of query.
        """
        return pulumi.get(self, "query_config")

    @property
    @pulumi.getter(name="suggestionFeature")
    def suggestion_feature(self) -> 'outputs.GoogleCloudDialogflowV2SuggestionFeatureResponse':
        """
        The suggestion feature.
        """
        return pulumi.get(self, "suggestion_feature")

    @property
    @pulumi.getter(name="suggestionTriggerSettings")
    def suggestion_trigger_settings(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionTriggerSettingsResponse':
        """
        Settings of suggestion trigger. Currently, only ARTICLE_SUGGESTION and FAQ will use this field.
        """
        return pulumi.get(self, "suggestion_trigger_settings")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigContextFilterSettingsResponse(dict):
    """
    Settings that determine how to filter recent conversation context when generating suggestions.
    """
    def __init__(__self__, *,
                 drop_handoff_messages: bool,
                 drop_ivr_messages: bool,
                 drop_virtual_agent_messages: bool):
        """
        Settings that determine how to filter recent conversation context when generating suggestions.
        :param bool drop_handoff_messages: If set to true, the last message from virtual agent (hand off message) and the message before it (trigger message of hand off) are dropped.
        :param bool drop_ivr_messages: If set to true, all messages from ivr stage are dropped.
        :param bool drop_virtual_agent_messages: If set to true, all messages from virtual agent are dropped.
        """
        pulumi.set(__self__, "drop_handoff_messages", drop_handoff_messages)
        pulumi.set(__self__, "drop_ivr_messages", drop_ivr_messages)
        pulumi.set(__self__, "drop_virtual_agent_messages", drop_virtual_agent_messages)

    @property
    @pulumi.getter(name="dropHandoffMessages")
    def drop_handoff_messages(self) -> bool:
        """
        If set to true, the last message from virtual agent (hand off message) and the message before it (trigger message of hand off) are dropped.
        """
        return pulumi.get(self, "drop_handoff_messages")

    @property
    @pulumi.getter(name="dropIvrMessages")
    def drop_ivr_messages(self) -> bool:
        """
        If set to true, all messages from ivr stage are dropped.
        """
        return pulumi.get(self, "drop_ivr_messages")

    @property
    @pulumi.getter(name="dropVirtualAgentMessages")
    def drop_virtual_agent_messages(self) -> bool:
        """
        If set to true, all messages from virtual agent are dropped.
        """
        return pulumi.get(self, "drop_virtual_agent_messages")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDialogflowQuerySourceResponse(dict):
    """
    Dialogflow source setting. Supported feature: DIALOGFLOW_ASSIST.
    """
    def __init__(__self__, *,
                 agent: str):
        """
        Dialogflow source setting. Supported feature: DIALOGFLOW_ASSIST.
        :param str agent: Required. The name of a Dialogflow virtual agent used for end user side intent detection and suggestion. Format: `projects//locations//agent`. When multiple agents are allowed in the same Dialogflow project.
        """
        pulumi.set(__self__, "agent", agent)

    @property
    @pulumi.getter
    def agent(self) -> str:
        """
        Required. The name of a Dialogflow virtual agent used for end user side intent detection and suggestion. Format: `projects//locations//agent`. When multiple agents are allowed in the same Dialogflow project.
        """
        return pulumi.get(self, "agent")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDocumentQuerySourceResponse(dict):
    """
    Document source settings. Supported features: SMART_REPLY, SMART_COMPOSE.
    """
    def __init__(__self__, *,
                 documents: Sequence[str]):
        """
        Document source settings. Supported features: SMART_REPLY, SMART_COMPOSE.
        :param Sequence[str] documents: Required. Knowledge documents to query from. Format: `projects//locations//knowledgeBases//documents/`. Currently, at most 5 documents are supported.
        """
        pulumi.set(__self__, "documents", documents)

    @property
    @pulumi.getter
    def documents(self) -> Sequence[str]:
        """
        Required. Knowledge documents to query from. Format: `projects//locations//knowledgeBases//documents/`. Currently, at most 5 documents are supported.
        """
        return pulumi.get(self, "documents")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigKnowledgeBaseQuerySourceResponse(dict):
    """
    Knowledge base source settings. Supported features: ARTICLE_SUGGESTION, FAQ.
    """
    def __init__(__self__, *,
                 knowledge_bases: Sequence[str]):
        """
        Knowledge base source settings. Supported features: ARTICLE_SUGGESTION, FAQ.
        :param Sequence[str] knowledge_bases: Required. Knowledge bases to query. Format: `projects//locations//knowledgeBases/`. Currently, at most 5 knowledge bases are supported.
        """
        pulumi.set(__self__, "knowledge_bases", knowledge_bases)

    @property
    @pulumi.getter(name="knowledgeBases")
    def knowledge_bases(self) -> Sequence[str]:
        """
        Required. Knowledge bases to query. Format: `projects//locations//knowledgeBases/`. Currently, at most 5 knowledge bases are supported.
        """
        return pulumi.get(self, "knowledge_bases")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigResponse(dict):
    """
    Config for suggestion query.
    """
    def __init__(__self__, *,
                 confidence_threshold: float,
                 context_filter_settings: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigContextFilterSettingsResponse',
                 dialogflow_query_source: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDialogflowQuerySourceResponse',
                 document_query_source: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDocumentQuerySourceResponse',
                 knowledge_base_query_source: 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigKnowledgeBaseQuerySourceResponse',
                 max_results: int):
        """
        Config for suggestion query.
        :param float confidence_threshold: Confidence threshold of query result. Agent Assist gives each suggestion a score in the range [0.0, 1.0], based on the relevance between the suggestion and the current conversation context. A score of 0.0 has no relevance, while a score of 1.0 has high relevance. Only suggestions with a score greater than or equal to the value of this field are included in the results. For a baseline model (the default), the recommended value is in the range [0.05, 0.1]. For a custom model, there is no recommended value. Tune this value by starting from a very low value and slowly increasing until you have desired results. If this field is not set, it defaults to 0.0, which means that all suggestions are returned. Supported features: ARTICLE_SUGGESTION.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigContextFilterSettingsResponseArgs' context_filter_settings: Determines how recent conversation context is filtered when generating suggestions. If unspecified, no messages will be dropped.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDialogflowQuerySourceResponseArgs' dialogflow_query_source: Query from Dialogflow agent. It is used by DIALOGFLOW_ASSIST.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDocumentQuerySourceResponseArgs' document_query_source: Query from knowledge base document. It is used by: SMART_REPLY, SMART_COMPOSE.
        :param 'GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigKnowledgeBaseQuerySourceResponseArgs' knowledge_base_query_source: Query from knowledgebase. It is used by: ARTICLE_SUGGESTION, FAQ.
        :param int max_results: Maximum number of results to return. Currently, if unset, defaults to 10. And the max number is 20.
        """
        pulumi.set(__self__, "confidence_threshold", confidence_threshold)
        pulumi.set(__self__, "context_filter_settings", context_filter_settings)
        pulumi.set(__self__, "dialogflow_query_source", dialogflow_query_source)
        pulumi.set(__self__, "document_query_source", document_query_source)
        pulumi.set(__self__, "knowledge_base_query_source", knowledge_base_query_source)
        pulumi.set(__self__, "max_results", max_results)

    @property
    @pulumi.getter(name="confidenceThreshold")
    def confidence_threshold(self) -> float:
        """
        Confidence threshold of query result. Agent Assist gives each suggestion a score in the range [0.0, 1.0], based on the relevance between the suggestion and the current conversation context. A score of 0.0 has no relevance, while a score of 1.0 has high relevance. Only suggestions with a score greater than or equal to the value of this field are included in the results. For a baseline model (the default), the recommended value is in the range [0.05, 0.1]. For a custom model, there is no recommended value. Tune this value by starting from a very low value and slowly increasing until you have desired results. If this field is not set, it defaults to 0.0, which means that all suggestions are returned. Supported features: ARTICLE_SUGGESTION.
        """
        return pulumi.get(self, "confidence_threshold")

    @property
    @pulumi.getter(name="contextFilterSettings")
    def context_filter_settings(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigContextFilterSettingsResponse':
        """
        Determines how recent conversation context is filtered when generating suggestions. If unspecified, no messages will be dropped.
        """
        return pulumi.get(self, "context_filter_settings")

    @property
    @pulumi.getter(name="dialogflowQuerySource")
    def dialogflow_query_source(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDialogflowQuerySourceResponse':
        """
        Query from Dialogflow agent. It is used by DIALOGFLOW_ASSIST.
        """
        return pulumi.get(self, "dialogflow_query_source")

    @property
    @pulumi.getter(name="documentQuerySource")
    def document_query_source(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigDocumentQuerySourceResponse':
        """
        Query from knowledge base document. It is used by: SMART_REPLY, SMART_COMPOSE.
        """
        return pulumi.get(self, "document_query_source")

    @property
    @pulumi.getter(name="knowledgeBaseQuerySource")
    def knowledge_base_query_source(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionQueryConfigKnowledgeBaseQuerySourceResponse':
        """
        Query from knowledgebase. It is used by: ARTICLE_SUGGESTION, FAQ.
        """
        return pulumi.get(self, "knowledge_base_query_source")

    @property
    @pulumi.getter(name="maxResults")
    def max_results(self) -> int:
        """
        Maximum number of results to return. Currently, if unset, defaults to 10. And the max number is 20.
        """
        return pulumi.get(self, "max_results")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentAssistantConfigSuggestionTriggerSettingsResponse(dict):
    """
    Settings of suggestion trigger.
    """
    def __init__(__self__, *,
                 no_smalltalk: bool,
                 only_end_user: bool):
        """
        Settings of suggestion trigger.
        :param bool no_smalltalk: Do not trigger if last utterance is small talk.
        :param bool only_end_user: Only trigger suggestion if participant role of last utterance is END_USER.
        """
        pulumi.set(__self__, "no_smalltalk", no_smalltalk)
        pulumi.set(__self__, "only_end_user", only_end_user)

    @property
    @pulumi.getter(name="noSmalltalk")
    def no_smalltalk(self) -> bool:
        """
        Do not trigger if last utterance is small talk.
        """
        return pulumi.get(self, "no_smalltalk")

    @property
    @pulumi.getter(name="onlyEndUser")
    def only_end_user(self) -> bool:
        """
        Only trigger suggestion if participant role of last utterance is END_USER.
        """
        return pulumi.get(self, "only_end_user")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentHandoffConfigLivePersonConfigResponse(dict):
    """
    Configuration specific to LivePerson (https://www.liveperson.com).
    """
    def __init__(__self__, *,
                 account_number: str):
        """
        Configuration specific to LivePerson (https://www.liveperson.com).
        :param str account_number: Required. Account number of the LivePerson account to connect. This is the account number you input at the login page.
        """
        pulumi.set(__self__, "account_number", account_number)

    @property
    @pulumi.getter(name="accountNumber")
    def account_number(self) -> str:
        """
        Required. Account number of the LivePerson account to connect. This is the account number you input at the login page.
        """
        return pulumi.get(self, "account_number")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentHandoffConfigResponse(dict):
    """
    Defines the hand off to a live agent, typically on which external agent service provider to connect to a conversation. Currently, this feature is not general available, please contact Google to get access.
    """
    def __init__(__self__, *,
                 live_person_config: 'outputs.GoogleCloudDialogflowV2HumanAgentHandoffConfigLivePersonConfigResponse',
                 salesforce_live_agent_config: 'outputs.GoogleCloudDialogflowV2HumanAgentHandoffConfigSalesforceLiveAgentConfigResponse'):
        """
        Defines the hand off to a live agent, typically on which external agent service provider to connect to a conversation. Currently, this feature is not general available, please contact Google to get access.
        :param 'GoogleCloudDialogflowV2HumanAgentHandoffConfigLivePersonConfigResponseArgs' live_person_config: Uses LivePerson (https://www.liveperson.com).
        :param 'GoogleCloudDialogflowV2HumanAgentHandoffConfigSalesforceLiveAgentConfigResponseArgs' salesforce_live_agent_config: Uses Salesforce Live Agent.
        """
        pulumi.set(__self__, "live_person_config", live_person_config)
        pulumi.set(__self__, "salesforce_live_agent_config", salesforce_live_agent_config)

    @property
    @pulumi.getter(name="livePersonConfig")
    def live_person_config(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentHandoffConfigLivePersonConfigResponse':
        """
        Uses LivePerson (https://www.liveperson.com).
        """
        return pulumi.get(self, "live_person_config")

    @property
    @pulumi.getter(name="salesforceLiveAgentConfig")
    def salesforce_live_agent_config(self) -> 'outputs.GoogleCloudDialogflowV2HumanAgentHandoffConfigSalesforceLiveAgentConfigResponse':
        """
        Uses Salesforce Live Agent.
        """
        return pulumi.get(self, "salesforce_live_agent_config")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2HumanAgentHandoffConfigSalesforceLiveAgentConfigResponse(dict):
    """
    Configuration specific to Salesforce Live Agent.
    """
    def __init__(__self__, *,
                 button_id: str,
                 deployment_id: str,
                 endpoint_domain: str,
                 organization_id: str):
        """
        Configuration specific to Salesforce Live Agent.
        :param str button_id: Required. Live Agent chat button ID.
        :param str deployment_id: Required. Live Agent deployment ID.
        :param str endpoint_domain: Required. Domain of the Live Agent endpoint for this agent. You can find the endpoint URL in the `Live Agent settings` page. For example if URL has the form https://d.la4-c2-phx.salesforceliveagent.com/..., you should fill in d.la4-c2-phx.salesforceliveagent.com.
        :param str organization_id: Required. The organization ID of the Salesforce account.
        """
        pulumi.set(__self__, "button_id", button_id)
        pulumi.set(__self__, "deployment_id", deployment_id)
        pulumi.set(__self__, "endpoint_domain", endpoint_domain)
        pulumi.set(__self__, "organization_id", organization_id)

    @property
    @pulumi.getter(name="buttonId")
    def button_id(self) -> str:
        """
        Required. Live Agent chat button ID.
        """
        return pulumi.get(self, "button_id")

    @property
    @pulumi.getter(name="deploymentId")
    def deployment_id(self) -> str:
        """
        Required. Live Agent deployment ID.
        """
        return pulumi.get(self, "deployment_id")

    @property
    @pulumi.getter(name="endpointDomain")
    def endpoint_domain(self) -> str:
        """
        Required. Domain of the Live Agent endpoint for this agent. You can find the endpoint URL in the `Live Agent settings` page. For example if URL has the form https://d.la4-c2-phx.salesforceliveagent.com/..., you should fill in d.la4-c2-phx.salesforceliveagent.com.
        """
        return pulumi.get(self, "endpoint_domain")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        """
        Required. The organization ID of the Salesforce account.
        """
        return pulumi.get(self, "organization_id")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentFollowupIntentInfoResponse(dict):
    """
    Represents a single followup intent in the chain.
    """
    def __init__(__self__, *,
                 followup_intent_name: str,
                 parent_followup_intent_name: str):
        """
        Represents a single followup intent in the chain.
        :param str followup_intent_name: The unique identifier of the followup intent. Format: `projects//agent/intents/`.
        :param str parent_followup_intent_name: The unique identifier of the followup intent's parent. Format: `projects//agent/intents/`.
        """
        pulumi.set(__self__, "followup_intent_name", followup_intent_name)
        pulumi.set(__self__, "parent_followup_intent_name", parent_followup_intent_name)

    @property
    @pulumi.getter(name="followupIntentName")
    def followup_intent_name(self) -> str:
        """
        The unique identifier of the followup intent. Format: `projects//agent/intents/`.
        """
        return pulumi.get(self, "followup_intent_name")

    @property
    @pulumi.getter(name="parentFollowupIntentName")
    def parent_followup_intent_name(self) -> str:
        """
        The unique identifier of the followup intent's parent. Format: `projects//agent/intents/`.
        """
        return pulumi.get(self, "parent_followup_intent_name")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageBasicCardButtonOpenUriActionResponse(dict):
    """
    Opens the given URI.
    """
    def __init__(__self__, *,
                 uri: str):
        """
        Opens the given URI.
        :param str uri: Required. The HTTP or HTTPS scheme URI.
        """
        pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter
    def uri(self) -> str:
        """
        Required. The HTTP or HTTPS scheme URI.
        """
        return pulumi.get(self, "uri")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageBasicCardButtonResponse(dict):
    """
    The button object that appears at the bottom of a card.
    """
    def __init__(__self__, *,
                 open_uri_action: 'outputs.GoogleCloudDialogflowV2IntentMessageBasicCardButtonOpenUriActionResponse',
                 title: str):
        """
        The button object that appears at the bottom of a card.
        :param 'GoogleCloudDialogflowV2IntentMessageBasicCardButtonOpenUriActionResponseArgs' open_uri_action: Required. Action to take when a user taps on the button.
        :param str title: Required. The title of the button.
        """
        pulumi.set(__self__, "open_uri_action", open_uri_action)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter(name="openUriAction")
    def open_uri_action(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageBasicCardButtonOpenUriActionResponse':
        """
        Required. Action to take when a user taps on the button.
        """
        return pulumi.get(self, "open_uri_action")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Required. The title of the button.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageBasicCardResponse(dict):
    """
    The basic card message. Useful for displaying information.
    """
    def __init__(__self__, *,
                 buttons: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageBasicCardButtonResponse'],
                 formatted_text: str,
                 image: 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse',
                 subtitle: str,
                 title: str):
        """
        The basic card message. Useful for displaying information.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageBasicCardButtonResponseArgs'] buttons: Optional. The collection of card buttons.
        :param str formatted_text: Required, unless image is present. The body text of the card.
        :param 'GoogleCloudDialogflowV2IntentMessageImageResponseArgs' image: Optional. The image for the card.
        :param str subtitle: Optional. The subtitle of the card.
        :param str title: Optional. The title of the card.
        """
        pulumi.set(__self__, "buttons", buttons)
        pulumi.set(__self__, "formatted_text", formatted_text)
        pulumi.set(__self__, "image", image)
        pulumi.set(__self__, "subtitle", subtitle)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def buttons(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageBasicCardButtonResponse']:
        """
        Optional. The collection of card buttons.
        """
        return pulumi.get(self, "buttons")

    @property
    @pulumi.getter(name="formattedText")
    def formatted_text(self) -> str:
        """
        Required, unless image is present. The body text of the card.
        """
        return pulumi.get(self, "formatted_text")

    @property
    @pulumi.getter
    def image(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse':
        """
        Optional. The image for the card.
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter
    def subtitle(self) -> str:
        """
        Optional. The subtitle of the card.
        """
        return pulumi.get(self, "subtitle")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Optional. The title of the card.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemOpenUrlActionResponse(dict):
    """
    Actions on Google action to open a given url.
    """
    def __init__(__self__, *,
                 url: str,
                 url_type_hint: str):
        """
        Actions on Google action to open a given url.
        :param str url: Required. URL
        :param str url_type_hint: Optional. Specifies the type of viewer that is used when opening the URL. Defaults to opening via web browser.
        """
        pulumi.set(__self__, "url", url)
        pulumi.set(__self__, "url_type_hint", url_type_hint)

    @property
    @pulumi.getter
    def url(self) -> str:
        """
        Required. URL
        """
        return pulumi.get(self, "url")

    @property
    @pulumi.getter(name="urlTypeHint")
    def url_type_hint(self) -> str:
        """
        Optional. Specifies the type of viewer that is used when opening the URL. Defaults to opening via web browser.
        """
        return pulumi.get(self, "url_type_hint")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemResponse(dict):
    """
    Browsing carousel tile
    """
    def __init__(__self__, *,
                 description: str,
                 footer: str,
                 image: 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse',
                 open_uri_action: 'outputs.GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemOpenUrlActionResponse',
                 title: str):
        """
        Browsing carousel tile
        :param str description: Optional. Description of the carousel item. Maximum of four lines of text.
        :param str footer: Optional. Text that appears at the bottom of the Browse Carousel Card. Maximum of one line of text.
        :param 'GoogleCloudDialogflowV2IntentMessageImageResponseArgs' image: Optional. Hero image for the carousel item.
        :param 'GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemOpenUrlActionResponseArgs' open_uri_action: Required. Action to present to the user.
        :param str title: Required. Title of the carousel item. Maximum of two lines of text.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "footer", footer)
        pulumi.set(__self__, "image", image)
        pulumi.set(__self__, "open_uri_action", open_uri_action)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Optional. Description of the carousel item. Maximum of four lines of text.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def footer(self) -> str:
        """
        Optional. Text that appears at the bottom of the Browse Carousel Card. Maximum of one line of text.
        """
        return pulumi.get(self, "footer")

    @property
    @pulumi.getter
    def image(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse':
        """
        Optional. Hero image for the carousel item.
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter(name="openUriAction")
    def open_uri_action(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemOpenUrlActionResponse':
        """
        Required. Action to present to the user.
        """
        return pulumi.get(self, "open_uri_action")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Required. Title of the carousel item. Maximum of two lines of text.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardResponse(dict):
    """
    Browse Carousel Card for Actions on Google. https://developers.google.com/actions/assistant/responses#browsing_carousel
    """
    def __init__(__self__, *,
                 image_display_options: str,
                 items: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemResponse']):
        """
        Browse Carousel Card for Actions on Google. https://developers.google.com/actions/assistant/responses#browsing_carousel
        :param str image_display_options: Optional. Settings for displaying the image. Applies to every image in items.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemResponseArgs'] items: Required. List of items in the Browse Carousel Card. Minimum of two items, maximum of ten.
        """
        pulumi.set(__self__, "image_display_options", image_display_options)
        pulumi.set(__self__, "items", items)

    @property
    @pulumi.getter(name="imageDisplayOptions")
    def image_display_options(self) -> str:
        """
        Optional. Settings for displaying the image. Applies to every image in items.
        """
        return pulumi.get(self, "image_display_options")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardBrowseCarouselCardItemResponse']:
        """
        Required. List of items in the Browse Carousel Card. Minimum of two items, maximum of ten.
        """
        return pulumi.get(self, "items")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageCardButtonResponse(dict):
    """
    Contains information about a button.
    """
    def __init__(__self__, *,
                 postback: str,
                 text: str):
        """
        Contains information about a button.
        :param str postback: Optional. The text to send back to the Dialogflow API or a URI to open.
        :param str text: Optional. The text to show on the button.
        """
        pulumi.set(__self__, "postback", postback)
        pulumi.set(__self__, "text", text)

    @property
    @pulumi.getter
    def postback(self) -> str:
        """
        Optional. The text to send back to the Dialogflow API or a URI to open.
        """
        return pulumi.get(self, "postback")

    @property
    @pulumi.getter
    def text(self) -> str:
        """
        Optional. The text to show on the button.
        """
        return pulumi.get(self, "text")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageCardResponse(dict):
    """
    The card response message.
    """
    def __init__(__self__, *,
                 buttons: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageCardButtonResponse'],
                 image_uri: str,
                 subtitle: str,
                 title: str):
        """
        The card response message.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageCardButtonResponseArgs'] buttons: Optional. The collection of card buttons.
        :param str image_uri: Optional. The public URI to an image file for the card.
        :param str subtitle: Optional. The subtitle of the card.
        :param str title: Optional. The title of the card.
        """
        pulumi.set(__self__, "buttons", buttons)
        pulumi.set(__self__, "image_uri", image_uri)
        pulumi.set(__self__, "subtitle", subtitle)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def buttons(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageCardButtonResponse']:
        """
        Optional. The collection of card buttons.
        """
        return pulumi.get(self, "buttons")

    @property
    @pulumi.getter(name="imageUri")
    def image_uri(self) -> str:
        """
        Optional. The public URI to an image file for the card.
        """
        return pulumi.get(self, "image_uri")

    @property
    @pulumi.getter
    def subtitle(self) -> str:
        """
        Optional. The subtitle of the card.
        """
        return pulumi.get(self, "subtitle")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Optional. The title of the card.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageCarouselSelectItemResponse(dict):
    """
    An item in the carousel.
    """
    def __init__(__self__, *,
                 description: str,
                 image: 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse',
                 info: 'outputs.GoogleCloudDialogflowV2IntentMessageSelectItemInfoResponse',
                 title: str):
        """
        An item in the carousel.
        :param str description: Optional. The body text of the card.
        :param 'GoogleCloudDialogflowV2IntentMessageImageResponseArgs' image: Optional. The image to display.
        :param 'GoogleCloudDialogflowV2IntentMessageSelectItemInfoResponseArgs' info: Required. Additional info about the option item.
        :param str title: Required. Title of the carousel item.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "image", image)
        pulumi.set(__self__, "info", info)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Optional. The body text of the card.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def image(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse':
        """
        Optional. The image to display.
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter
    def info(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageSelectItemInfoResponse':
        """
        Required. Additional info about the option item.
        """
        return pulumi.get(self, "info")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Required. Title of the carousel item.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageCarouselSelectResponse(dict):
    """
    The card for presenting a carousel of options to select from.
    """
    def __init__(__self__, *,
                 items: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageCarouselSelectItemResponse']):
        """
        The card for presenting a carousel of options to select from.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageCarouselSelectItemResponseArgs'] items: Required. Carousel items.
        """
        pulumi.set(__self__, "items", items)

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageCarouselSelectItemResponse']:
        """
        Required. Carousel items.
        """
        return pulumi.get(self, "items")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageColumnPropertiesResponse(dict):
    """
    Column properties for TableCard.
    """
    def __init__(__self__, *,
                 header: str,
                 horizontal_alignment: str):
        """
        Column properties for TableCard.
        :param str header: Required. Column heading.
        :param str horizontal_alignment: Optional. Defines text alignment for all cells in this column.
        """
        pulumi.set(__self__, "header", header)
        pulumi.set(__self__, "horizontal_alignment", horizontal_alignment)

    @property
    @pulumi.getter
    def header(self) -> str:
        """
        Required. Column heading.
        """
        return pulumi.get(self, "header")

    @property
    @pulumi.getter(name="horizontalAlignment")
    def horizontal_alignment(self) -> str:
        """
        Optional. Defines text alignment for all cells in this column.
        """
        return pulumi.get(self, "horizontal_alignment")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageImageResponse(dict):
    """
    The image response message.
    """
    def __init__(__self__, *,
                 accessibility_text: str,
                 image_uri: str):
        """
        The image response message.
        :param str accessibility_text: Optional. A text description of the image to be used for accessibility, e.g., screen readers.
        :param str image_uri: Optional. The public URI to an image file.
        """
        pulumi.set(__self__, "accessibility_text", accessibility_text)
        pulumi.set(__self__, "image_uri", image_uri)

    @property
    @pulumi.getter(name="accessibilityText")
    def accessibility_text(self) -> str:
        """
        Optional. A text description of the image to be used for accessibility, e.g., screen readers.
        """
        return pulumi.get(self, "accessibility_text")

    @property
    @pulumi.getter(name="imageUri")
    def image_uri(self) -> str:
        """
        Optional. The public URI to an image file.
        """
        return pulumi.get(self, "image_uri")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageLinkOutSuggestionResponse(dict):
    """
    The suggestion chip message that allows the user to jump out to the app or website associated with this agent.
    """
    def __init__(__self__, *,
                 destination_name: str,
                 uri: str):
        """
        The suggestion chip message that allows the user to jump out to the app or website associated with this agent.
        :param str destination_name: Required. The name of the app or site this chip is linking to.
        :param str uri: Required. The URI of the app or site to open when the user taps the suggestion chip.
        """
        pulumi.set(__self__, "destination_name", destination_name)
        pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter(name="destinationName")
    def destination_name(self) -> str:
        """
        Required. The name of the app or site this chip is linking to.
        """
        return pulumi.get(self, "destination_name")

    @property
    @pulumi.getter
    def uri(self) -> str:
        """
        Required. The URI of the app or site to open when the user taps the suggestion chip.
        """
        return pulumi.get(self, "uri")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageListSelectItemResponse(dict):
    """
    An item in the list.
    """
    def __init__(__self__, *,
                 description: str,
                 image: 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse',
                 info: 'outputs.GoogleCloudDialogflowV2IntentMessageSelectItemInfoResponse',
                 title: str):
        """
        An item in the list.
        :param str description: Optional. The main text describing the item.
        :param 'GoogleCloudDialogflowV2IntentMessageImageResponseArgs' image: Optional. The image to display.
        :param 'GoogleCloudDialogflowV2IntentMessageSelectItemInfoResponseArgs' info: Required. Additional information about this option.
        :param str title: Required. The title of the list item.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "image", image)
        pulumi.set(__self__, "info", info)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Optional. The main text describing the item.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def image(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse':
        """
        Optional. The image to display.
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter
    def info(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageSelectItemInfoResponse':
        """
        Required. Additional information about this option.
        """
        return pulumi.get(self, "info")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Required. The title of the list item.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageListSelectResponse(dict):
    """
    The card for presenting a list of options to select from.
    """
    def __init__(__self__, *,
                 items: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageListSelectItemResponse'],
                 subtitle: str,
                 title: str):
        """
        The card for presenting a list of options to select from.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageListSelectItemResponseArgs'] items: Required. List items.
        :param str subtitle: Optional. Subtitle of the list.
        :param str title: Optional. The overall title of the list.
        """
        pulumi.set(__self__, "items", items)
        pulumi.set(__self__, "subtitle", subtitle)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageListSelectItemResponse']:
        """
        Required. List items.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter
    def subtitle(self) -> str:
        """
        Optional. Subtitle of the list.
        """
        return pulumi.get(self, "subtitle")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Optional. The overall title of the list.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageMediaContentResponse(dict):
    """
    The media content card for Actions on Google.
    """
    def __init__(__self__, *,
                 media_objects: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageMediaContentResponseMediaObjectResponse'],
                 media_type: str):
        """
        The media content card for Actions on Google.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageMediaContentResponseMediaObjectResponseArgs'] media_objects: Required. List of media objects.
        :param str media_type: Optional. What type of media is the content (ie "audio").
        """
        pulumi.set(__self__, "media_objects", media_objects)
        pulumi.set(__self__, "media_type", media_type)

    @property
    @pulumi.getter(name="mediaObjects")
    def media_objects(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageMediaContentResponseMediaObjectResponse']:
        """
        Required. List of media objects.
        """
        return pulumi.get(self, "media_objects")

    @property
    @pulumi.getter(name="mediaType")
    def media_type(self) -> str:
        """
        Optional. What type of media is the content (ie "audio").
        """
        return pulumi.get(self, "media_type")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageMediaContentResponseMediaObjectResponse(dict):
    """
    Response media object for media content card.
    """
    def __init__(__self__, *,
                 content_url: str,
                 description: str,
                 icon: 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse',
                 large_image: 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse',
                 name: str):
        """
        Response media object for media content card.
        :param str content_url: Required. Url where the media is stored.
        :param str description: Optional. Description of media card.
        :param 'GoogleCloudDialogflowV2IntentMessageImageResponseArgs' icon: Optional. Icon to display above media content.
        :param 'GoogleCloudDialogflowV2IntentMessageImageResponseArgs' large_image: Optional. Image to display above media content.
        :param str name: Required. Name of media card.
        """
        pulumi.set(__self__, "content_url", content_url)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "icon", icon)
        pulumi.set(__self__, "large_image", large_image)
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="contentUrl")
    def content_url(self) -> str:
        """
        Required. Url where the media is stored.
        """
        return pulumi.get(self, "content_url")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Optional. Description of media card.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def icon(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse':
        """
        Optional. Icon to display above media content.
        """
        return pulumi.get(self, "icon")

    @property
    @pulumi.getter(name="largeImage")
    def large_image(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse':
        """
        Optional. Image to display above media content.
        """
        return pulumi.get(self, "large_image")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Required. Name of media card.
        """
        return pulumi.get(self, "name")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageQuickRepliesResponse(dict):
    """
    The quick replies response message.
    """
    def __init__(__self__, *,
                 quick_replies: Sequence[str],
                 title: str):
        """
        The quick replies response message.
        :param Sequence[str] quick_replies: Optional. The collection of quick replies.
        :param str title: Optional. The title of the collection of quick replies.
        """
        pulumi.set(__self__, "quick_replies", quick_replies)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter(name="quickReplies")
    def quick_replies(self) -> Sequence[str]:
        """
        Optional. The collection of quick replies.
        """
        return pulumi.get(self, "quick_replies")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Optional. The title of the collection of quick replies.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageResponse(dict):
    """
    A rich response message. Corresponds to the intent `Response` field in the Dialogflow console. For more information, see [Rich response messages](https://cloud.google.com/dialogflow/docs/intents-rich-messages).
    """
    def __init__(__self__, *,
                 basic_card: 'outputs.GoogleCloudDialogflowV2IntentMessageBasicCardResponse',
                 browse_carousel_card: 'outputs.GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardResponse',
                 card: 'outputs.GoogleCloudDialogflowV2IntentMessageCardResponse',
                 carousel_select: 'outputs.GoogleCloudDialogflowV2IntentMessageCarouselSelectResponse',
                 image: 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse',
                 link_out_suggestion: 'outputs.GoogleCloudDialogflowV2IntentMessageLinkOutSuggestionResponse',
                 list_select: 'outputs.GoogleCloudDialogflowV2IntentMessageListSelectResponse',
                 media_content: 'outputs.GoogleCloudDialogflowV2IntentMessageMediaContentResponse',
                 payload: Mapping[str, str],
                 platform: str,
                 quick_replies: 'outputs.GoogleCloudDialogflowV2IntentMessageQuickRepliesResponse',
                 simple_responses: 'outputs.GoogleCloudDialogflowV2IntentMessageSimpleResponsesResponse',
                 suggestions: 'outputs.GoogleCloudDialogflowV2IntentMessageSuggestionsResponse',
                 table_card: 'outputs.GoogleCloudDialogflowV2IntentMessageTableCardResponse',
                 text: 'outputs.GoogleCloudDialogflowV2IntentMessageTextResponse'):
        """
        A rich response message. Corresponds to the intent `Response` field in the Dialogflow console. For more information, see [Rich response messages](https://cloud.google.com/dialogflow/docs/intents-rich-messages).
        :param 'GoogleCloudDialogflowV2IntentMessageBasicCardResponseArgs' basic_card: The basic card response for Actions on Google.
        :param 'GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardResponseArgs' browse_carousel_card: Browse carousel card for Actions on Google.
        :param 'GoogleCloudDialogflowV2IntentMessageCardResponseArgs' card: The card response.
        :param 'GoogleCloudDialogflowV2IntentMessageCarouselSelectResponseArgs' carousel_select: The carousel card response for Actions on Google.
        :param 'GoogleCloudDialogflowV2IntentMessageImageResponseArgs' image: The image response.
        :param 'GoogleCloudDialogflowV2IntentMessageLinkOutSuggestionResponseArgs' link_out_suggestion: The link out suggestion chip for Actions on Google.
        :param 'GoogleCloudDialogflowV2IntentMessageListSelectResponseArgs' list_select: The list card response for Actions on Google.
        :param 'GoogleCloudDialogflowV2IntentMessageMediaContentResponseArgs' media_content: The media content card for Actions on Google.
        :param Mapping[str, str] payload: A custom platform-specific response.
        :param str platform: Optional. The platform that this message is intended for.
        :param 'GoogleCloudDialogflowV2IntentMessageQuickRepliesResponseArgs' quick_replies: The quick replies response.
        :param 'GoogleCloudDialogflowV2IntentMessageSimpleResponsesResponseArgs' simple_responses: The voice and text-only responses for Actions on Google.
        :param 'GoogleCloudDialogflowV2IntentMessageSuggestionsResponseArgs' suggestions: The suggestion chips for Actions on Google.
        :param 'GoogleCloudDialogflowV2IntentMessageTableCardResponseArgs' table_card: Table card for Actions on Google.
        :param 'GoogleCloudDialogflowV2IntentMessageTextResponseArgs' text: The text response.
        """
        pulumi.set(__self__, "basic_card", basic_card)
        pulumi.set(__self__, "browse_carousel_card", browse_carousel_card)
        pulumi.set(__self__, "card", card)
        pulumi.set(__self__, "carousel_select", carousel_select)
        pulumi.set(__self__, "image", image)
        pulumi.set(__self__, "link_out_suggestion", link_out_suggestion)
        pulumi.set(__self__, "list_select", list_select)
        pulumi.set(__self__, "media_content", media_content)
        pulumi.set(__self__, "payload", payload)
        pulumi.set(__self__, "platform", platform)
        pulumi.set(__self__, "quick_replies", quick_replies)
        pulumi.set(__self__, "simple_responses", simple_responses)
        pulumi.set(__self__, "suggestions", suggestions)
        pulumi.set(__self__, "table_card", table_card)
        pulumi.set(__self__, "text", text)

    @property
    @pulumi.getter(name="basicCard")
    def basic_card(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageBasicCardResponse':
        """
        The basic card response for Actions on Google.
        """
        return pulumi.get(self, "basic_card")

    @property
    @pulumi.getter(name="browseCarouselCard")
    def browse_carousel_card(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageBrowseCarouselCardResponse':
        """
        Browse carousel card for Actions on Google.
        """
        return pulumi.get(self, "browse_carousel_card")

    @property
    @pulumi.getter
    def card(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageCardResponse':
        """
        The card response.
        """
        return pulumi.get(self, "card")

    @property
    @pulumi.getter(name="carouselSelect")
    def carousel_select(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageCarouselSelectResponse':
        """
        The carousel card response for Actions on Google.
        """
        return pulumi.get(self, "carousel_select")

    @property
    @pulumi.getter
    def image(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse':
        """
        The image response.
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter(name="linkOutSuggestion")
    def link_out_suggestion(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageLinkOutSuggestionResponse':
        """
        The link out suggestion chip for Actions on Google.
        """
        return pulumi.get(self, "link_out_suggestion")

    @property
    @pulumi.getter(name="listSelect")
    def list_select(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageListSelectResponse':
        """
        The list card response for Actions on Google.
        """
        return pulumi.get(self, "list_select")

    @property
    @pulumi.getter(name="mediaContent")
    def media_content(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageMediaContentResponse':
        """
        The media content card for Actions on Google.
        """
        return pulumi.get(self, "media_content")

    @property
    @pulumi.getter
    def payload(self) -> Mapping[str, str]:
        """
        A custom platform-specific response.
        """
        return pulumi.get(self, "payload")

    @property
    @pulumi.getter
    def platform(self) -> str:
        """
        Optional. The platform that this message is intended for.
        """
        return pulumi.get(self, "platform")

    @property
    @pulumi.getter(name="quickReplies")
    def quick_replies(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageQuickRepliesResponse':
        """
        The quick replies response.
        """
        return pulumi.get(self, "quick_replies")

    @property
    @pulumi.getter(name="simpleResponses")
    def simple_responses(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageSimpleResponsesResponse':
        """
        The voice and text-only responses for Actions on Google.
        """
        return pulumi.get(self, "simple_responses")

    @property
    @pulumi.getter
    def suggestions(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageSuggestionsResponse':
        """
        The suggestion chips for Actions on Google.
        """
        return pulumi.get(self, "suggestions")

    @property
    @pulumi.getter(name="tableCard")
    def table_card(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageTableCardResponse':
        """
        Table card for Actions on Google.
        """
        return pulumi.get(self, "table_card")

    @property
    @pulumi.getter
    def text(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageTextResponse':
        """
        The text response.
        """
        return pulumi.get(self, "text")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageSelectItemInfoResponse(dict):
    """
    Additional info about the select item for when it is triggered in a dialog.
    """
    def __init__(__self__, *,
                 key: str,
                 synonyms: Sequence[str]):
        """
        Additional info about the select item for when it is triggered in a dialog.
        :param str key: Required. A unique key that will be sent back to the agent if this response is given.
        :param Sequence[str] synonyms: Optional. A list of synonyms that can also be used to trigger this item in dialog.
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "synonyms", synonyms)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Required. A unique key that will be sent back to the agent if this response is given.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def synonyms(self) -> Sequence[str]:
        """
        Optional. A list of synonyms that can also be used to trigger this item in dialog.
        """
        return pulumi.get(self, "synonyms")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageSimpleResponseResponse(dict):
    """
    The simple response message containing speech or text.
    """
    def __init__(__self__, *,
                 display_text: str,
                 ssml: str,
                 text_to_speech: str):
        """
        The simple response message containing speech or text.
        :param str display_text: Optional. The text to display.
        :param str ssml: One of text_to_speech or ssml must be provided. Structured spoken response to the user in the SSML format. Mutually exclusive with text_to_speech.
        :param str text_to_speech: One of text_to_speech or ssml must be provided. The plain text of the speech output. Mutually exclusive with ssml.
        """
        pulumi.set(__self__, "display_text", display_text)
        pulumi.set(__self__, "ssml", ssml)
        pulumi.set(__self__, "text_to_speech", text_to_speech)

    @property
    @pulumi.getter(name="displayText")
    def display_text(self) -> str:
        """
        Optional. The text to display.
        """
        return pulumi.get(self, "display_text")

    @property
    @pulumi.getter
    def ssml(self) -> str:
        """
        One of text_to_speech or ssml must be provided. Structured spoken response to the user in the SSML format. Mutually exclusive with text_to_speech.
        """
        return pulumi.get(self, "ssml")

    @property
    @pulumi.getter(name="textToSpeech")
    def text_to_speech(self) -> str:
        """
        One of text_to_speech or ssml must be provided. The plain text of the speech output. Mutually exclusive with ssml.
        """
        return pulumi.get(self, "text_to_speech")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageSimpleResponsesResponse(dict):
    """
    The collection of simple response candidates. This message in `QueryResult.fulfillment_messages` and `WebhookResponse.fulfillment_messages` should contain only one `SimpleResponse`.
    """
    def __init__(__self__, *,
                 simple_responses: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageSimpleResponseResponse']):
        """
        The collection of simple response candidates. This message in `QueryResult.fulfillment_messages` and `WebhookResponse.fulfillment_messages` should contain only one `SimpleResponse`.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageSimpleResponseResponseArgs'] simple_responses: Required. The list of simple responses.
        """
        pulumi.set(__self__, "simple_responses", simple_responses)

    @property
    @pulumi.getter(name="simpleResponses")
    def simple_responses(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageSimpleResponseResponse']:
        """
        Required. The list of simple responses.
        """
        return pulumi.get(self, "simple_responses")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageSuggestionResponse(dict):
    """
    The suggestion chip message that the user can tap to quickly post a reply to the conversation.
    """
    def __init__(__self__, *,
                 title: str):
        """
        The suggestion chip message that the user can tap to quickly post a reply to the conversation.
        :param str title: Required. The text shown the in the suggestion chip.
        """
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Required. The text shown the in the suggestion chip.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageSuggestionsResponse(dict):
    """
    The collection of suggestions.
    """
    def __init__(__self__, *,
                 suggestions: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageSuggestionResponse']):
        """
        The collection of suggestions.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageSuggestionResponseArgs'] suggestions: Required. The list of suggested replies.
        """
        pulumi.set(__self__, "suggestions", suggestions)

    @property
    @pulumi.getter
    def suggestions(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageSuggestionResponse']:
        """
        Required. The list of suggested replies.
        """
        return pulumi.get(self, "suggestions")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageTableCardCellResponse(dict):
    """
    Cell of TableCardRow.
    """
    def __init__(__self__, *,
                 text: str):
        """
        Cell of TableCardRow.
        :param str text: Required. Text in this cell.
        """
        pulumi.set(__self__, "text", text)

    @property
    @pulumi.getter
    def text(self) -> str:
        """
        Required. Text in this cell.
        """
        return pulumi.get(self, "text")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageTableCardResponse(dict):
    """
    Table card for Actions on Google.
    """
    def __init__(__self__, *,
                 buttons: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageBasicCardButtonResponse'],
                 column_properties: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageColumnPropertiesResponse'],
                 image: 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse',
                 rows: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageTableCardRowResponse'],
                 subtitle: str,
                 title: str):
        """
        Table card for Actions on Google.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageBasicCardButtonResponseArgs'] buttons: Optional. List of buttons for the card.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageColumnPropertiesResponseArgs'] column_properties: Optional. Display properties for the columns in this table.
        :param 'GoogleCloudDialogflowV2IntentMessageImageResponseArgs' image: Optional. Image which should be displayed on the card.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageTableCardRowResponseArgs'] rows: Optional. Rows in this table of data.
        :param str subtitle: Optional. Subtitle to the title.
        :param str title: Required. Title of the card.
        """
        pulumi.set(__self__, "buttons", buttons)
        pulumi.set(__self__, "column_properties", column_properties)
        pulumi.set(__self__, "image", image)
        pulumi.set(__self__, "rows", rows)
        pulumi.set(__self__, "subtitle", subtitle)
        pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def buttons(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageBasicCardButtonResponse']:
        """
        Optional. List of buttons for the card.
        """
        return pulumi.get(self, "buttons")

    @property
    @pulumi.getter(name="columnProperties")
    def column_properties(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageColumnPropertiesResponse']:
        """
        Optional. Display properties for the columns in this table.
        """
        return pulumi.get(self, "column_properties")

    @property
    @pulumi.getter
    def image(self) -> 'outputs.GoogleCloudDialogflowV2IntentMessageImageResponse':
        """
        Optional. Image which should be displayed on the card.
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter
    def rows(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageTableCardRowResponse']:
        """
        Optional. Rows in this table of data.
        """
        return pulumi.get(self, "rows")

    @property
    @pulumi.getter
    def subtitle(self) -> str:
        """
        Optional. Subtitle to the title.
        """
        return pulumi.get(self, "subtitle")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        Required. Title of the card.
        """
        return pulumi.get(self, "title")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageTableCardRowResponse(dict):
    """
    Row of TableCard.
    """
    def __init__(__self__, *,
                 cells: Sequence['outputs.GoogleCloudDialogflowV2IntentMessageTableCardCellResponse'],
                 divider_after: bool):
        """
        Row of TableCard.
        :param Sequence['GoogleCloudDialogflowV2IntentMessageTableCardCellResponseArgs'] cells: Optional. List of cells that make up this row.
        :param bool divider_after: Optional. Whether to add a visual divider after this row.
        """
        pulumi.set(__self__, "cells", cells)
        pulumi.set(__self__, "divider_after", divider_after)

    @property
    @pulumi.getter
    def cells(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentMessageTableCardCellResponse']:
        """
        Optional. List of cells that make up this row.
        """
        return pulumi.get(self, "cells")

    @property
    @pulumi.getter(name="dividerAfter")
    def divider_after(self) -> bool:
        """
        Optional. Whether to add a visual divider after this row.
        """
        return pulumi.get(self, "divider_after")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentMessageTextResponse(dict):
    """
    The text response message.
    """
    def __init__(__self__, *,
                 text: Sequence[str]):
        """
        The text response message.
        :param Sequence[str] text: Optional. The collection of the agent's responses.
        """
        pulumi.set(__self__, "text", text)

    @property
    @pulumi.getter
    def text(self) -> Sequence[str]:
        """
        Optional. The collection of the agent's responses.
        """
        return pulumi.get(self, "text")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentParameterResponse(dict):
    """
    Represents intent parameters.
    """
    def __init__(__self__, *,
                 default_value: str,
                 display_name: str,
                 entity_type_display_name: str,
                 is_list: bool,
                 mandatory: bool,
                 name: str,
                 prompts: Sequence[str],
                 value: str):
        """
        Represents intent parameters.
        :param str default_value: Optional. The default value to use when the `value` yields an empty result. Default values can be extracted from contexts by using the following syntax: `#context_name.parameter_name`.
        :param str display_name: Required. The name of the parameter.
        :param str entity_type_display_name: Optional. The name of the entity type, prefixed with `@`, that describes values of the parameter. If the parameter is required, this must be provided.
        :param bool is_list: Optional. Indicates whether the parameter represents a list of values.
        :param bool mandatory: Optional. Indicates whether the parameter is required. That is, whether the intent cannot be completed without collecting the parameter value.
        :param str name: The unique identifier of this parameter.
        :param Sequence[str] prompts: Optional. The collection of prompts that the agent can present to the user in order to collect a value for the parameter.
        :param str value: Optional. The definition of the parameter value. It can be: - a constant string, - a parameter value defined as `$parameter_name`, - an original parameter value defined as `$parameter_name.original`, - a parameter value from some context defined as `#context_name.parameter_name`.
        """
        pulumi.set(__self__, "default_value", default_value)
        pulumi.set(__self__, "display_name", display_name)
        pulumi.set(__self__, "entity_type_display_name", entity_type_display_name)
        pulumi.set(__self__, "is_list", is_list)
        pulumi.set(__self__, "mandatory", mandatory)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "prompts", prompts)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="defaultValue")
    def default_value(self) -> str:
        """
        Optional. The default value to use when the `value` yields an empty result. Default values can be extracted from contexts by using the following syntax: `#context_name.parameter_name`.
        """
        return pulumi.get(self, "default_value")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        Required. The name of the parameter.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="entityTypeDisplayName")
    def entity_type_display_name(self) -> str:
        """
        Optional. The name of the entity type, prefixed with `@`, that describes values of the parameter. If the parameter is required, this must be provided.
        """
        return pulumi.get(self, "entity_type_display_name")

    @property
    @pulumi.getter(name="isList")
    def is_list(self) -> bool:
        """
        Optional. Indicates whether the parameter represents a list of values.
        """
        return pulumi.get(self, "is_list")

    @property
    @pulumi.getter
    def mandatory(self) -> bool:
        """
        Optional. Indicates whether the parameter is required. That is, whether the intent cannot be completed without collecting the parameter value.
        """
        return pulumi.get(self, "mandatory")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The unique identifier of this parameter.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def prompts(self) -> Sequence[str]:
        """
        Optional. The collection of prompts that the agent can present to the user in order to collect a value for the parameter.
        """
        return pulumi.get(self, "prompts")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Optional. The definition of the parameter value. It can be: - a constant string, - a parameter value defined as `$parameter_name`, - an original parameter value defined as `$parameter_name.original`, - a parameter value from some context defined as `#context_name.parameter_name`.
        """
        return pulumi.get(self, "value")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentTrainingPhrasePartResponse(dict):
    """
    Represents a part of a training phrase.
    """
    def __init__(__self__, *,
                 alias: str,
                 entity_type: str,
                 text: str,
                 user_defined: bool):
        """
        Represents a part of a training phrase.
        :param str alias: Optional. The parameter name for the value extracted from the annotated part of the example. This field is required for annotated parts of the training phrase.
        :param str entity_type: Optional. The entity type name prefixed with `@`. This field is required for annotated parts of the training phrase.
        :param str text: Required. The text for this part.
        :param bool user_defined: Optional. Indicates whether the text was manually annotated. This field is set to true when the Dialogflow Console is used to manually annotate the part. When creating an annotated part with the API, you must set this to true.
        """
        pulumi.set(__self__, "alias", alias)
        pulumi.set(__self__, "entity_type", entity_type)
        pulumi.set(__self__, "text", text)
        pulumi.set(__self__, "user_defined", user_defined)

    @property
    @pulumi.getter
    def alias(self) -> str:
        """
        Optional. The parameter name for the value extracted from the annotated part of the example. This field is required for annotated parts of the training phrase.
        """
        return pulumi.get(self, "alias")

    @property
    @pulumi.getter(name="entityType")
    def entity_type(self) -> str:
        """
        Optional. The entity type name prefixed with `@`. This field is required for annotated parts of the training phrase.
        """
        return pulumi.get(self, "entity_type")

    @property
    @pulumi.getter
    def text(self) -> str:
        """
        Required. The text for this part.
        """
        return pulumi.get(self, "text")

    @property
    @pulumi.getter(name="userDefined")
    def user_defined(self) -> bool:
        """
        Optional. Indicates whether the text was manually annotated. This field is set to true when the Dialogflow Console is used to manually annotate the part. When creating an annotated part with the API, you must set this to true.
        """
        return pulumi.get(self, "user_defined")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2IntentTrainingPhraseResponse(dict):
    """
    Represents an example that the agent is trained on.
    """
    def __init__(__self__, *,
                 name: str,
                 parts: Sequence['outputs.GoogleCloudDialogflowV2IntentTrainingPhrasePartResponse'],
                 times_added_count: int,
                 type: str):
        """
        Represents an example that the agent is trained on.
        :param str name: The unique identifier of this training phrase.
        :param Sequence['GoogleCloudDialogflowV2IntentTrainingPhrasePartResponseArgs'] parts: Required. The ordered list of training phrase parts. The parts are concatenated in order to form the training phrase. Note: The API does not automatically annotate training phrases like the Dialogflow Console does. Note: Do not forget to include whitespace at part boundaries, so the training phrase is well formatted when the parts are concatenated. If the training phrase does not need to be annotated with parameters, you just need a single part with only the Part.text field set. If you want to annotate the training phrase, you must create multiple parts, where the fields of each part are populated in one of two ways: - `Part.text` is set to a part of the phrase that has no parameters. - `Part.text` is set to a part of the phrase that you want to annotate, and the `entity_type`, `alias`, and `user_defined` fields are all set.
        :param int times_added_count: Optional. Indicates how many times this example was added to the intent. Each time a developer adds an existing sample by editing an intent or training, this counter is increased.
        :param str type: Required. The type of the training phrase.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "parts", parts)
        pulumi.set(__self__, "times_added_count", times_added_count)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The unique identifier of this training phrase.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def parts(self) -> Sequence['outputs.GoogleCloudDialogflowV2IntentTrainingPhrasePartResponse']:
        """
        Required. The ordered list of training phrase parts. The parts are concatenated in order to form the training phrase. Note: The API does not automatically annotate training phrases like the Dialogflow Console does. Note: Do not forget to include whitespace at part boundaries, so the training phrase is well formatted when the parts are concatenated. If the training phrase does not need to be annotated with parameters, you just need a single part with only the Part.text field set. If you want to annotate the training phrase, you must create multiple parts, where the fields of each part are populated in one of two ways: - `Part.text` is set to a part of the phrase that has no parameters. - `Part.text` is set to a part of the phrase that you want to annotate, and the `entity_type`, `alias`, and `user_defined` fields are all set.
        """
        return pulumi.get(self, "parts")

    @property
    @pulumi.getter(name="timesAddedCount")
    def times_added_count(self) -> int:
        """
        Optional. Indicates how many times this example was added to the intent. Each time a developer adds an existing sample by editing an intent or training, this counter is increased.
        """
        return pulumi.get(self, "times_added_count")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Required. The type of the training phrase.
        """
        return pulumi.get(self, "type")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2LoggingConfigResponse(dict):
    """
    Defines logging behavior for conversation lifecycle events.
    """
    def __init__(__self__, *,
                 enable_stackdriver_logging: bool):
        """
        Defines logging behavior for conversation lifecycle events.
        :param bool enable_stackdriver_logging: Whether to log conversation events like CONVERSATION_STARTED to Stackdriver in the conversation project as JSON format ConversationEvent protos.
        """
        pulumi.set(__self__, "enable_stackdriver_logging", enable_stackdriver_logging)

    @property
    @pulumi.getter(name="enableStackdriverLogging")
    def enable_stackdriver_logging(self) -> bool:
        """
        Whether to log conversation events like CONVERSATION_STARTED to Stackdriver in the conversation project as JSON format ConversationEvent protos.
        """
        return pulumi.get(self, "enable_stackdriver_logging")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2NotificationConfigResponse(dict):
    """
    Defines notification behavior.
    """
    def __init__(__self__, *,
                 message_format: str,
                 topic: str):
        """
        Defines notification behavior.
        :param str message_format: Format of message.
        :param str topic: Name of the Pub/Sub topic to publish conversation events like CONVERSATION_STARTED as serialized ConversationEvent protos. Notification works for phone calls, if this topic either is in the same project as the conversation or you grant `service-@gcp-sa-dialogflow.iam.gserviceaccount.com` the `Dialogflow Service Agent` role in the topic project. Format: `projects//locations//topics/`.
        """
        pulumi.set(__self__, "message_format", message_format)
        pulumi.set(__self__, "topic", topic)

    @property
    @pulumi.getter(name="messageFormat")
    def message_format(self) -> str:
        """
        Format of message.
        """
        return pulumi.get(self, "message_format")

    @property
    @pulumi.getter
    def topic(self) -> str:
        """
        Name of the Pub/Sub topic to publish conversation events like CONVERSATION_STARTED as serialized ConversationEvent protos. Notification works for phone calls, if this topic either is in the same project as the conversation or you grant `service-@gcp-sa-dialogflow.iam.gserviceaccount.com` the `Dialogflow Service Agent` role in the topic project. Format: `projects//locations//topics/`.
        """
        return pulumi.get(self, "topic")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2SpeechToTextConfigResponse(dict):
    """
    Configures speech transcription for ConversationProfile.
    """
    def __init__(__self__, *,
                 speech_model_variant: str):
        """
        Configures speech transcription for ConversationProfile.
        :param str speech_model_variant: Optional. The speech model used in speech to text. `SPEECH_MODEL_VARIANT_UNSPECIFIED`, `USE_BEST_AVAILABLE` will be treated as `USE_ENHANCED`. It can be overridden in AnalyzeContentRequest and StreamingAnalyzeContentRequest request.
        """
        pulumi.set(__self__, "speech_model_variant", speech_model_variant)

    @property
    @pulumi.getter(name="speechModelVariant")
    def speech_model_variant(self) -> str:
        """
        Optional. The speech model used in speech to text. `SPEECH_MODEL_VARIANT_UNSPECIFIED`, `USE_BEST_AVAILABLE` will be treated as `USE_ENHANCED`. It can be overridden in AnalyzeContentRequest and StreamingAnalyzeContentRequest request.
        """
        return pulumi.get(self, "speech_model_variant")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleCloudDialogflowV2SuggestionFeatureResponse(dict):
    """
    The type of Human Agent Assistant API suggestion to perform, and the maximum number of results to return for that type. Multiple `Feature` objects can be specified in the `features` list.
    """
    def __init__(__self__, *,
                 type: str):
        """
        The type of Human Agent Assistant API suggestion to perform, and the maximum number of results to return for that type. Multiple `Feature` objects can be specified in the `features` list.
        :param str type: Type of Human Agent Assistant API feature to request.
        """
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Type of Human Agent Assistant API feature to request.
        """
        return pulumi.get(self, "type")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


@pulumi.output_type
class GoogleRpcStatusResponse(dict):
    """
    The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).
    """
    def __init__(__self__, *,
                 code: int,
                 details: Sequence[Mapping[str, str]],
                 message: str):
        """
        The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).
        :param int code: The status code, which should be an enum value of google.rpc.Code.
        :param Sequence[Mapping[str, str]] details: A list of messages that carry the error details. There is a common set of message types for APIs to use.
        :param str message: A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.
        """
        pulumi.set(__self__, "code", code)
        pulumi.set(__self__, "details", details)
        pulumi.set(__self__, "message", message)

    @property
    @pulumi.getter
    def code(self) -> int:
        """
        The status code, which should be an enum value of google.rpc.Code.
        """
        return pulumi.get(self, "code")

    @property
    @pulumi.getter
    def details(self) -> Sequence[Mapping[str, str]]:
        """
        A list of messages that carry the error details. There is a common set of message types for APIs to use.
        """
        return pulumi.get(self, "details")

    @property
    @pulumi.getter
    def message(self) -> str:
        """
        A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.
        """
        return pulumi.get(self, "message")

    def _translate_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop


